<template>
  <div class="bg-white pt-5 rounded-lg shadow">
    <div class="px-6 pb-8">
      <!-- Widget Header -->
      <div
        class="flex grow justify-between items-center pb-5 border-b border-gray-100 mb-8 sm:block"
      >
        <div class="flex gap-1 sm:pb-2">
          <app-widget-title :title="ACTIVITIES_LEADERBOARD_WIDGET.name" />
        </div>
        <app-widget-period
          :template="ACTIVITIES_REPORT.nameAsId"
          :widget="ACTIVITIES_LEADERBOARD_WIDGET.name"
          :period="selectedPeriod"
          module="reports"
          @on-update="onUpdatePeriod"
        />
      </div>

      <app-widget-activities-type-list
        :filters="filters"
        :selected-period="selectedPeriod"
        :limit="10"
      >
        <template #button="{ showButton }">
          <div v-if="showButton" class="flex justify-end">
            <el-button
              class="btn btn-link btn-link--primary mt-4 !h-8"
              @click="handleDrawerOpen"
            >
              View all
            </el-button>
          </div>
        </template>
      </app-widget-activities-type-list>

      <app-widget-cube-drawer
        v-if="drawerExpanded"
        v-model="drawerExpanded"
        :title="drawerTitle"
        :period="drawerSelectedPeriod"
        :template="ACTIVITIES_REPORT.nameAsId"
        size="480px"
        @on-period-update="onDrawerUpdatePeriod"
      >
        <template #drawerContent>
          <app-widget-activities-type-list
            :filters="filters"
            :selected-period="drawerSelectedPeriod"
          />
        </template>
      </app-widget-cube-drawer>
    </div>
  </div>
</template>

<script setup>
import { SEVEN_DAYS_PERIOD_FILTER } from '@/modules/widget/widget-constants';
import { getSelectedPeriodFromLabel } from '@/modules/widget/widget-utility';
import { ref } from 'vue';
import AppWidgetTitle from '@/modules/widget/components/shared/widget-title.vue';
import AppWidgetPeriod from '@/modules/widget/components/shared/widget-period.vue';
import AppWidgetCubeDrawer from '@/modules/widget/components/shared/widget-cube-drawer.vue';
import ACTIVITIES_REPORT, {
  ACTIVITIES_LEADERBOARD_WIDGET,
} from '@/modules/report/templates/config/activities';
import AppWidgetActivitiesTypeList from '@/modules/widget/components/activity/widget-activities-type-list.vue';
import { useRoute, useRouter } from 'vue-router';

defineProps({
  filters: {
    type: Object,
    default: null,
  },
});

const route = useRoute();
const router = useRouter();
const drawerExpanded = ref();
const drawerTitle = ref('Leaderboard: Activities by type');

const selectedPeriod = ref(
  getSelectedPeriodFromLabel(
    route.query.leaderboardActivitiesByTypePeriod,
    SEVEN_DAYS_PERIOD_FILTER,
  ),
);
const drawerSelectedPeriod = ref(SEVEN_DAYS_PERIOD_FILTER);

const onUpdatePeriod = (updatedPeriod) => {
  selectedPeriod.value = updatedPeriod;
  router.replace({
    query: {
      ...route.query,
      leaderboardActivitiesByTypePeriod: updatedPeriod.label,
    },
  });
};

const onDrawerUpdatePeriod = (updatedPeriod) => {
  drawerSelectedPeriod.value = updatedPeriod;
};

const handleDrawerOpen = () => {
  window.analytics?.track('Open report drawer', {
    template: ACTIVITIES_REPORT.nameAsId,
    widget: ACTIVITIES_LEADERBOARD_WIDGET.name,
    period: drawerSelectedPeriod.value,
  });

  drawerExpanded.value = true;
  drawerSelectedPeriod.value = SEVEN_DAYS_PERIOD_FILTER;
};
</script>

<script>
export default {
  name: 'AppWidgetActivitiesLeaderboard',
};
</script>
